/***************************************************************************
                                  Logger.C 
                             -------------------
    begin                : 2001
    copyright            : (C)2001-2003 Multi-Agent Systems Laboratory,
                           University of Science and Technology of China 
                           Zhanxiang Huang, Yang Yang and Xiaoping Chen.
    email                : huangzx@mail.ustc.edu.cn 
 ***************************************************************************/

#include "Logger.h"

Logger::Logger(const char* logfileName,const char mark,int iLineBufLength)
{
    // default open mode = ios::out|ios::trunc
    _os.open(logfileName, ios::out|ios::trunc);

    // assure the file has been opened
    assert(_os);
    
    _bufLength = iLineBufLength;
    _lineBuf = new char[_bufLength];
    
    _fmtMark = mark;

}


Logger::Logger(const string logfileName , const char mark,int iLineBufLength)
{
    Logger(logfileName.c_str(),mark,iLineBufLength);
}



Logger::~Logger()
{
    _os.close();
    delete [] _lineBuf;
}



void Logger::SetFmtMark(const char mark)
{
    _fmtMark = mark;
}


// Log һеʽṩprintfĸʽlogļϢģʽ
// level : ΪĶlogfile㣬levelָ˼logϢǰĸʽĸ
void Logger::Log(int level,char *fmt,...)
{
    va_list argp;
    
    // initialize argument list:argp
    va_start(argp,fmt);
    
    // print log info to _lineBuf
    vsnprintf(_lineBuf,_bufLength,fmt,argp);
    
    va_end(argp);
    
    // output log info to stream
    _os << setfill(_fmtMark);
    _os << setw( strlen(_lineBuf)+level )
        << _lineBuf << endl;
    
}

// ID: ָļlogϢǰlogID
// level : ΪĶlogfile㣬levelָ˼logϢǰĸʽĸ
void Logger::Log(int ID,int level,char *fmt,...)
{
    va_list argp;
    
    // initialize argument list:argp
    va_start(argp,fmt);
    
    // print log info to _lineBuf
    vsnprintf(_lineBuf,_bufLength,fmt,argp);
    
    va_end(argp);
    
    // output log info to stream
    _os << ID << " " << setfill(_fmtMark);
    
    _os <<  setw( strlen(_lineBuf)+level )
        << _lineBuf <<  endl;
    
}

