/***************************************************************************
                                  Parse.h 
                             -------------------
    begin                : 2001
    copyright            : (C)2001-2003 Multi-Agent Systems Laboratory,
                           University of Science and Technology of China 
                           Zhanxiang Huang, Yang Yang and Xiaoping Chen.
    email                : huangzx@mail.ustc.edu.cn
 ***************************************************************************/

#ifndef _PARSE_H_
#define _PARSE_H_

#include <cstring>
#include <string>
#include <stdio.h>
#include "WorldModel.h"

using namespace std;


enum MsgT{
        MSG_UNEXPECTED,
        MSG_SEE,
        MSG_HEAR,
        MSG_ACK,
        MSG_ERROR,
        MSG_WARNING,
        MSG_SERVER_PARAM,
        MSG_PLAYER_PARAM,
        MSG_PLAYER_TYPE,
        MSG_INIT
};
       

class Parse{
public:
        Parse(const string &teamName);
        Parse(const char *teamName);
        
        //Function which parse msgs from server and Set correspondent informations to temp data structure;
        MsgT ParseMsg(const char* Msg,WMSnapShot &wms);
        MsgT ParseMsg(const string &Msg,WMSnapShot &wms);
        
        void SetOurTeamName(const char *teamName);
    
private:
        int ParseSee(const char* Msg,WMSnapShot &wms);
        int ParseHear(const char* Msg,WMSnapShot &wms);
        
        int ParseACK(const char* Msg,WMSnapShot &wms);
        int ParseError(const char* Msg,WMSnapShot &wms);
        int ParseWarning(const char* Msg,WMSnapShot &wms);
        
        int ParseServerParam(const char* Msg,WMSnapShot &wms);
        int ParsePlayerParam(const char* Msg,WMSnapShot &wms);
        int ParsePlayerType(const char* Msg,WMSnapShot &wms);
        
        int GetToken(char* &pszMsg, char *buf);

        char ourTeamName[64]; // use for parse see message

        // ж϶Ƿ֪
        bool bOppNameSet;
        bool bOurNameSet;
        
        bool bOppGoalieSet;
        bool bOurGoalieSet;

};


#endif

