/***************************************************************************
                               ServerSetting.C 
                             -------------------
    begin                : 2001
    copyright            : (C)2001-2003 Multi-Agent Systems Laboratory,
                           University of Science and Technology of China 
                           Zhanxiang Huang, Yang Yang and Xiaoping Chen.
    email                : huangzx@mail.ustc.edu.cn
 ***************************************************************************/

#include "ServerSetting.h"


ServerSetting::ServerSetting(void)
{
}

void ServerSetting::SetLogger(Logger *log)
{
    l = log;
}
    
int ServerSetting::SetServerParameters(const char* s)
{
    istrstream sp((char*)s,strlen(s));
    string strBuf;
    //sp << s;
        sp>>strBuf>>strBuf
        >>catch_ban_cycle>>strBuf//5)
        >>clang_advice_win>>strBuf//1)
        >>clang_define_win>>strBuf//1)
        >>clang_info_win>>strBuf//1)
        >>clang_mess_delay>>strBuf//50)
        >>clang_mess_per_cycle>>strBuf//1)
        >>clang_meta_win>>strBuf//1)
        >>clang_win_size>>strBuf//300)
        >>coach_port>>strBuf//6001)
        >>drop_ball_time>>strBuf//200)
        >>freeform_send_period>>strBuf//20)
        >>freeform_wait_period>>strBuf//600)
        >>game_log_compression>>strBuf//0)
        >>game_log_version>>strBuf//3)
        >>goalie_max_moves>>strBuf//2)
        >>half_time>>strBuf//3000)
        >>hear_decay>>strBuf//1)
        >>hear_inc>>strBuf//1)
        >>hear_max>>strBuf//1)
        >>max_goal_kicks>>strBuf//3)
        >>olcoach_port>>strBuf//6002)
        >>point_to_ban>>strBuf//5)
        >>point_to_duration>>strBuf//20)
        >>port>>strBuf//6000)
        >>recv_step>>strBuf//10)
        >>say_coach_cnt_max>>strBuf//128)
        >>say_coach_msg_size>>strBuf//128)
        >>say_msg_size>>strBuf//10)
        >>send_step>>strBuf//150)
        >>send_vi_step>>strBuf//100)
        >>sense_body_step>>strBuf//100)
        >>simulator_step>>strBuf//100)
        >>slow_down_factor>>strBuf//1)
        >>start_goal_l>>strBuf//0)
        >>start_goal_r>>strBuf//0)
        >>synch_micro_sleep>>strBuf//1)
        >>synch_offset>>strBuf//60)
        >>tackle_cycles>>strBuf//10)
        >>text_log_compression>>strBuf//0)
        >>game_log_dir//"./")
        >>game_log_fixed_name//"rcssserver")
        >>landmark_file//"~/.rcssserver-landmark.xml")
        >>log_date_format//"%Y%m%d%H%M-")
        >>replay//"")
        >>text_log_dir//"./")
        >>text_log_fixed_name//"rcssserver")
        >>coach>>strBuf//0)
        >>coach_w_referee>>strBuf//0)
        >>old_coach_hear>>strBuf//0)
        >>wind_none>>strBuf//0)
        >>wind_random>>strBuf//0)
        >>back_passes>>strBuf//1)
        >>forbid_kick_off_offside>>strBuf//1)
        >>free_kick_faults>>strBuf//1)
        >>fullstate_l>>strBuf//0)
        >>fullstate_r>>strBuf//0)
        >>game_log_dated>>strBuf//1)
        >>game_log_fixed>>strBuf//0)
        >>game_logging>>strBuf//1)
        >>log_times>>strBuf//1)
        >>profile>>strBuf//0)
        >>proper_goal_kicks>>strBuf//1)
        >>record_messages>>strBuf//1)
        >>send_comms>>strBuf//1)
        >>synch_mode>>strBuf//0)
        >>team_actuator_noise>>strBuf//0)
        >>text_log_dated>>strBuf//1)
        >>text_log_fixed>>strBuf//0)
        >>text_logging>>strBuf//1)
        >>use_offside>>strBuf//1)
        >>verbose>>strBuf//0)
        >>audio_cut_dist>>strBuf//50)
        >>ball_accel_max>>strBuf//2.7)
        >>ball_decay>>strBuf//0.94)
        >>ball_rand>>strBuf//0.05)
        >>ball_size>>strBuf//0.085)
        >>ball_speed_max>>strBuf//2.7)
        >>ball_weight>>strBuf//0.2)
        >>catch_probability>>strBuf//1)
        >>catchable_area_l>>strBuf//2)
        >>catchable_area_w>>strBuf//1)
        >>ckick_margin>>strBuf//1)
        >>control_radius>>strBuf//2)
        >>dash_power_rate>>strBuf//0.006)
        >>effort_dec>>strBuf//0.005)
        >>effort_dec_thr>>strBuf//0.3)
        >>effort_inc>>strBuf//0.01)
        >>effort_inc_thr>>strBuf//0.6)
        >>effort_init>>strBuf//0)
        >>effort_min>>strBuf//0.6)
        >>goal_width>>strBuf//14.02)
        >>inertia_moment>>strBuf//5)
        >>kick_power_rate>>strBuf//0.027)
        >>kick_rand>>strBuf//0)
        >>kick_rand_factor_l>>strBuf//1)
        >>kick_rand_factor_r>>strBuf//1)
        >>kickable_margin>>strBuf//0.7)
        >>maxmoment>>strBuf//180)
        >>maxneckang>>strBuf//90
        >>maxneckmoment>>strBuf//180)
        >>maxpower>>strBuf//100)
        >>minmoment>>strBuf//-180)
        >>minneckang>>strBuf//-90)
        >>minneckmoment>>strBuf//-180)
        >>minpower>>strBuf//-100)
        >>offside_active_area_size>>strBuf//5)
        >>offside_kick_margin>>strBuf//9.15)
        >>player_accel_max>>strBuf//1)
        >>player_decay>>strBuf//0.4)
        >>player_rand>>strBuf//0.1)
        >>player_size>>strBuf//0.3)
        >>player_speed_max>>strBuf//1)
        >>player_weight>>strBuf//60)
        >>prand_factor_l>>strBuf//1)
        >>prand_factor_r>>strBuf//1)
        >>quantize_step>>strBuf//0.1)
        >>quantize_step_l>>strBuf//0.01)
        >>recover_dec>>strBuf//0.002)
        >>recover_dec_thr>>strBuf//0.3)
        >>recover_min>>strBuf//0.5)
        >>slowness_on_top_for_left_team>>strBuf//1)
        >>slowness_on_top_for_right_team>>strBuf//1)
        >>stamina_inc_max>>strBuf//45)
        >>stamina_max>>strBuf//4000)
        >>stopped_ball_vel>>strBuf//0.01)
        >>tackle_back_dist>>strBuf//0.5)
        >>tackle_dist>>strBuf//2.5)
        >>tackle_exponent>>strBuf//6)
        >>tackle_power_rate>>strBuf//0.027)
        >>tackle_width>>strBuf//1.25)
        >>visible_angle>>strBuf//90)
        >>visible_distance>>strBuf//3)
        >>wind_ang>>strBuf//0)
        >>wind_dir>>strBuf//0)
        >>wind_force>>strBuf//0)
        >>wind_rand>>strBuf;//0)

    return 0;
}


int ServerSetting::SetServerParametersOld(const char* s)
{
    istrstream sp((char*)s,strlen(s));
    string strBuf;
    //sp << s;
    sp>>strBuf>>strBuf
    >>goal_width>>strBuf>>strBuf
    >>player_size>>strBuf>>strBuf
    >>player_decay>>strBuf>>strBuf
    >>player_rand>>strBuf>>strBuf
    >>player_weight>>strBuf>>strBuf
    >>player_speed_Max>>strBuf>>strBuf
    >>player_accel_Max>>strBuf>>strBuf
    >>staMina_Max>>strBuf>>strBuf
    >>staMina_inc_Max>>strBuf>>strBuf
    >>recover_init>>strBuf>>strBuf
    >>recover_dec_thr>>strBuf>>strBuf
    >>recover_Min>>strBuf>>strBuf
    >>recover_dec>>strBuf>>strBuf
    >>effort_init>>strBuf>>strBuf
    >>effort_dec_thr>>strBuf>>strBuf
    >>effort_Min>>strBuf>>strBuf
    >>effort_dec>>strBuf>>strBuf
    >>effort_inc_thr>>strBuf>>strBuf
    >>effort_inc>>strBuf>>strBuf
    >>kick_rand>>strBuf>>strBuf
    >>team_actuator_noise>>strBuf>>strBuf
    >>prand_factor_l>>strBuf>>strBuf
    >>prand_factor_r>>strBuf>>strBuf
    >>kick_rand_factor_l>>strBuf>>strBuf
    >>kick_rand_factor_r>>strBuf>>strBuf
    >>ball_size>>strBuf>>strBuf
    >>ball_decay>>strBuf>>strBuf
    >>ball_rand>>strBuf>>strBuf
    >>ball_weight>>strBuf>>strBuf
    >>ball_speed_Max>>strBuf>>strBuf
    >>ball_accel_Max>>strBuf>>strBuf
    >>dash_power_rate>>strBuf>>strBuf
    >>kick_power_rate>>strBuf>>strBuf
    >>kickable_margin>>strBuf>>strBuf
    >>control_radius>>strBuf>>strBuf
    >>control_radius_width>>strBuf>>strBuf
    >>catch_probability>>strBuf>>strBuf
    >>catchable_area_l>>strBuf>>strBuf
    >>catchable_area_w>>strBuf>>strBuf
    >>goalie_Max_moves>>strBuf>>strBuf
    >>Maxpower>>strBuf>>strBuf
    >>Minpower>>strBuf>>strBuf
    >>Maxmoment>>strBuf>>strBuf
    >>Minmoment>>strBuf>>strBuf
    >>Maxneckmoment>>strBuf>>strBuf
    >>Minneckmoment>>strBuf>>strBuf
    >>Maxneckang>>strBuf>>strBuf
    >>Minneckang>>strBuf>>strBuf
    >>visible_angle>>strBuf>>strBuf
    >>visible_distance>>strBuf>>strBuf
    >>audio_cut_dist>>strBuf>>strBuf
    >>quantize_step>>strBuf>>strBuf
    >>quantize_step_l>>strBuf>>strBuf
    >>quantize_step_dir>>strBuf>>strBuf
    >>quantize_step_dist_team_l>>strBuf>>strBuf
    >>quantize_step_dist_team_r>>strBuf>>strBuf
    >>quantize_step_dist_l_team_l>>strBuf>>strBuf
    >>quantize_step_dist_l_team_r>>strBuf>>strBuf
    >>quantize_step_dir_team_l>>strBuf>>strBuf
    >>quantize_step_dir_team_r>>strBuf>>strBuf
    >>ckick_margin>>strBuf>>strBuf
    >>wind_dir>>strBuf>>strBuf
    >>wind_force>>strBuf>>strBuf
    >>wind_ang>>strBuf>>strBuf
    >>wind_rand>>strBuf>>strBuf
    >>kickable_area>>strBuf>>strBuf
    >>inertia_moment>>strBuf>>strBuf
    >>wind_none>>strBuf>>strBuf
    >>wind_random>>strBuf>>strBuf
    >>half_time>>strBuf>>strBuf
    >>drop_ball_time>>strBuf>>strBuf
    >>port>>strBuf>>strBuf
    >>coach_port>>strBuf>>strBuf
    >>olcoach_port>>strBuf>>strBuf
    >>say_coach_cnt_Max>>strBuf>>strBuf
    >>say_coach_msg_size>>strBuf>>strBuf
    >>simulator_step>>strBuf>>strBuf
    >>send_step>>strBuf>>strBuf
    >>recv_step>>strBuf>>strBuf
    >>sense_body_step>>strBuf>>strBuf
    >>lcm_step>>strBuf>>strBuf
    >>say_msg_size>>strBuf>>strBuf
    >>clang_win_size>>strBuf>>strBuf
    >>clang_define_win>>strBuf>>strBuf
    >>clang_meta_win>>strBuf>>strBuf
    >>clang_advice_win>>strBuf>>strBuf
    >>clang_info_win>>strBuf>>strBuf
    >>clang_mess_delay>>strBuf>>strBuf
    >>clang_mess_per_cycle>>strBuf>>strBuf
    >>hear_Max>>strBuf>>strBuf
    >>hear_inc>>strBuf>>strBuf
    >>hear_decay>>strBuf>>strBuf
    >>catch_ban_cycle>>strBuf>>strBuf
    >>coach>>strBuf>>strBuf
    >>coach_w_referee>>strBuf>>strBuf
    >>old_coach_hear>>strBuf>>strBuf
    >>send_vi_step>>strBuf>>strBuf
    >>use_offside>>strBuf>>strBuf
    >>offside_active_area_size>>strBuf>>strBuf
    >>forbid_kick_off_offside>>strBuf>>strBuf
    >>verbose>>strBuf>>strBuf
    >>replay>>strBuf>>strBuf
    >>offside_kick_margin>>strBuf>>strBuf
    >>slow_down_factor>>strBuf>>strBuf
    >>synch_mode>>strBuf>>strBuf
    >>synch_offSet>>strBuf>>strBuf
    >>synch_micro_sleep>>strBuf>>strBuf
    >>start_goal_l>>strBuf>>strBuf
    >>start_goal_r>>strBuf>>strBuf
    >>fullstate_l>>strBuf>>strBuf
    >>fullstate_r>>strBuf>>strBuf
    >>slowness_on_top_for_left_team>>strBuf>>strBuf
    >>slowness_on_top_for_right_team>>strBuf>>strBuf
    >>send_comms>>strBuf>>strBuf
    >>text_logging>>strBuf>>strBuf
    >>game_logging>>strBuf>>strBuf
    >>game_log_version>>strBuf>>strBuf
    >>text_log_dir              >>strBuf
    >>game_log_dir              >>strBuf
    >>text_log_fixed_name       >>strBuf
    >>game_log_fixed_name       >>strBuf
    >>text_log_fixed>>strBuf>>strBuf
    >>game_log_fixed>>strBuf>>strBuf
    >>text_log_dated>>strBuf>>strBuf
    >>game_log_dated>>strBuf>>strBuf
    >>log_date_format           >>strBuf
    >>log_times>>strBuf>>strBuf
    >>record_messages>>strBuf>>strBuf
    >>text_log_compression>>strBuf>>strBuf
    >>game_log_compression>>strBuf>>strBuf
    >>profile>>strBuf>>strBuf
    >>point_to_ban>>strBuf>>strBuf
    >>point_to_duration;

    return 0;
}


int ServerSetting::OutServerParameters()
{
    cout<<endl<<endl
        <<catch_ban_cycle<<"   "//5)
        <<clang_advice_win<<"   "//1)
        <<clang_define_win<<"   "//1)
        <<clang_info_win<<"   "//1)
        <<clang_mess_delay<<"   "//50)
        <<clang_mess_per_cycle<<"   "//1)
        <<clang_meta_win<<"   "//1)
        <<clang_win_size<<"   "//300)
        <<coach_port<<"   "//6001)
        <<drop_ball_time<<"   "//200)
        <<freeform_send_period<<"   "//20)
        <<freeform_wait_period<<"   "//600)
        <<game_log_compression<<"   "//0)
        <<game_log_version<<"   "//3)
        <<goalie_max_moves<<"   "//2)
        <<half_time<<"   "//3000)
        <<hear_decay<<"   "//1)
        <<hear_inc<<"   "//1)
        <<hear_max<<"   "//1)
        <<max_goal_kicks<<"   "//3)
        <<olcoach_port<<"   "//6002)
        <<point_to_ban<<"   "//5)
        <<point_to_duration<<"   "//20)
        <<port<<"   "//6000)
        <<recv_step<<"   "//10)
        <<say_coach_cnt_max<<"   "//128)
        <<say_coach_msg_size<<"   "//128)
        <<say_msg_size<<"   "//10)
        <<send_step<<"   "//150)
        <<send_vi_step<<"   "//100)
        <<sense_body_step<<"   "//100)
        <<simulator_step<<"   "//100)
        <<slow_down_factor<<"   "//1)
        <<start_goal_l<<"   "//0)
        <<start_goal_r<<"   "//0)
        <<synch_micro_sleep<<"   "//1)
        <<synch_offset<<"   "//60)
        <<tackle_cycles<<"   "//10)
        <<text_log_compression<<"   "//0)
        <<game_log_dir<<"   "//"./")
        <<game_log_fixed_name<<"   "//"rcssserver")
        <<landmark_file<<"   "//"~/.rcssserver-landmark.xml")
        <<log_date_format<<"   "//"%Y%m%d%H%M-")
        <<replay<<"   "//"")
        <<text_log_dir<<"   "//"./")
        <<text_log_fixed_name<<"   "//"rcssserver")
        <<coach<<"   "//0)
        <<coach_w_referee<<"   "//0)
        <<old_coach_hear<<"   "//0)
        <<wind_none<<"   "//0)
        <<wind_random<<"   "//0)
        <<back_passes<<"   "//1)
        <<forbid_kick_off_offside<<"   "//1)
        <<free_kick_faults<<"   "//1)
        <<fullstate_l<<"   "//0)
        <<fullstate_r<<"   "//0)
        <<game_log_dated<<"   "//1)
        <<game_log_fixed<<"   "//0)
        <<game_logging<<"   "//1)
        <<log_times<<"   "//1)
        <<profile<<"   "//0)
        <<proper_goal_kicks<<"   "//1)
        <<record_messages<<"   "//1)
        <<send_comms<<"   "//1)
        <<synch_mode<<"   "//0)
        <<team_actuator_noise<<"   "//0)
        <<text_log_dated<<"   "//1)
        <<text_log_fixed<<"   "//0)
        <<text_logging<<"   "//1)
        <<use_offside<<"   "//1)
        <<verbose<<"   "//0)
        <<audio_cut_dist<<"   "//50)
        <<ball_accel_max<<"   "//2.7)
        <<ball_decay<<"   "//0.94)
        <<ball_rand<<"   "//0.05)
        <<ball_size<<"   "//0.085)
        <<ball_speed_max<<"   "//2.7)
        <<ball_weight<<"   "//0.2)
        <<catch_probability<<"   "//1)
        <<catchable_area_l<<"   "//2)
        <<catchable_area_w<<"   "//1)
        <<ckick_margin<<"   "//1)
        <<control_radius<<"   "//2)
        <<dash_power_rate<<"   "//0.006)
        <<effort_dec<<"   "//0.005)
        <<effort_dec_thr<<"   "//0.3)
        <<effort_inc<<"   "//0.01)
        <<effort_inc_thr<<"   "//0.6)
        <<effort_init<<"   "//0)
        <<effort_min<<"   "//0.6)
        <<goal_width<<"   "//14.02)
        <<inertia_moment<<"   "//5)
        <<kick_power_rate<<"   "//0.027)
        <<kick_rand<<"   "//0)
        <<kick_rand_factor_l<<"   "//1)
        <<kick_rand_factor_r<<"   "//1)
        <<kickable_margin<<"   "//0.7)
        <<maxmoment<<"   "//180)
        <<maxneckang<<"   "//90
        <<maxneckmoment<<"   "//180)
        <<maxpower<<"   "//100)
        <<minmoment<<"   "//-180)
        <<minneckang<<"   "//-90)
        <<minneckmoment<<"   "//-180)
        <<minpower<<"   "//-100)
        <<offside_active_area_size<<"   "//5)
        <<offside_kick_margin<<"   "//9.15)
        <<player_accel_max<<"   "//1)
        <<player_decay<<"   "//0.4)
        <<player_rand<<"   "//0.1)
        <<player_size<<"   "//0.3)
        <<player_speed_max<<"   "//1)
        <<player_weight<<"   "//60)
        <<prand_factor_l<<"   "//1)
        <<prand_factor_r<<"   "//1)
        <<quantize_step<<"   "//0.1)
        <<quantize_step_l<<"   "//0.01)
        <<recover_dec<<"   "//0.002)
        <<recover_dec_thr<<"   "//0.3)
        <<recover_min<<"   "//0.5)
        <<slowness_on_top_for_left_team<<"   "//1)
        <<slowness_on_top_for_right_team<<"   "//1)
        <<stamina_inc_max<<"   "//45)
        <<stamina_max<<"   "//4000)
        <<stopped_ball_vel<<"   "//0.01)
        <<tackle_back_dist<<"   "//0.5)
        <<tackle_dist<<"   "//2.5)
        <<tackle_exponent<<"   "//6)
        <<tackle_power_rate<<"   "//0.027)
        <<tackle_width<<"   "//1.25)
        <<visible_angle<<"   "//90)
        <<visible_distance<<"   "//3)
        <<wind_ang<<"   "//0)
        <<wind_dir<<"   "//0)
        <<wind_force<<"   "//0)
        <<wind_rand<<endl;//0)

    return 0;
}



PlayerSetting::PlayerSetting(void)
{
}

void PlayerSetting::SetLogger(Logger *log)
{
    l = log;
}


int PlayerSetting::SetPlayerParameters(const char* p)
{
    strstream sp;
    string strBuf;
    sp  <<  p;
    sp  >>                                      strBuf  >>  strBuf
         >>player_types        >>strBuf  //7)
        >>pt_max        >>strBuf  //3)
        >>random_seed        >>strBuf  //-1)
        >>subs_max        >>strBuf  //3)
        >>dash_power_rate_delta_max        >>strBuf  //0.002)
        >>dash_power_rate_delta_min        >>strBuf  //0)
        >>effort_max_delta_factor        >>strBuf  //-0.002)
        >>effort_min_delta_factor        >>strBuf  //-0.002)
        >>extra_stamina_delta_max        >>strBuf  //100)
        >>extra_stamina_delta_min        >>strBuf  //0)
        >>inertia_moment_delta_factor        >>strBuf  //25)
        >>kick_rand_delta_factor        >>strBuf  //0.5)
        >>kickable_margin_delta_max        >>strBuf  //0.2)
        >>kickable_margin_delta_min        >>strBuf  //0)
        >>new_dash_power_rate_delta_max        >>strBuf  //0.002)
        >>new_dash_power_rate_delta_min        >>strBuf  //0)
        >>new_stamina_inc_max_delta_factor        >>strBuf  //-10000)
        >>player_decay_delta_max        >>strBuf  //0.2)
        >>player_decay_delta_min        >>strBuf  //0)
        >>player_size_delta_factor        >>strBuf  //-100)
        >>player_speed_max_delta_max        >>strBuf  //0.2)
        >>player_speed_max_delta_min        >>strBuf  //0)
        >>stamina_inc_max_delta_factor        >>strBuf  ;//-100)
    return 0;
}



int PlayerSetting::SetPlayerParametersOld(const char* p)
{
    strstream sp;
    string strBuf;
    sp  <<  p;
    sp  >>                                      strBuf  >>  strBuf
        >>  player_types                    >>  strBuf  >>  strBuf
        >>  subs_Max                        >>  strBuf  >>  strBuf
        >>  pt_Max                          >>  strBuf  >>  strBuf
        >>  player_speed_Max_delta_Min      >>  strBuf  >>  strBuf
        >>  player_speed_Max_delta_Max      >>  strBuf  >>  strBuf
        >>  staMina_inc_Max_delta_factor    >>  strBuf  >>  strBuf
        >>  player_decay_delta_Min          >>  strBuf  >>  strBuf
        >>  player_decay_delta_Max          >>  strBuf  >>  strBuf
        >>  inertia_moment_delta_factor     >>  strBuf  >>  strBuf
        >>  dash_power_rate_delta_Min       >>  strBuf  >>  strBuf
        >>  dash_power_rate_delta_Max       >>  strBuf  >>  strBuf
        >>  player_size_delta_factor        >>  strBuf  >>  strBuf
        >>  kickable_margin_delta_Min       >>  strBuf  >>  strBuf
        >>  kickable_margin_delta_Max       >>  strBuf  >>  strBuf
        >>  kick_rand_delta_factor          >>  strBuf  >>  strBuf
        >>  extra_staMina_delta_Min         >>  strBuf  >>  strBuf
        >>  extra_staMina_delta_Max         >>  strBuf  >>  strBuf
        >>  effort_Max_delta_factor         >>  strBuf  >>  strBuf
        >>  inteffort_Min_delta_factor      >>  strBuf  >>  strBuf
        >>  random_seed;

    return 0;
}


int PlayerSetting::OutPlayerParameters()
{
    cout<<                                      endl <<  endl
        <<player_types        <<"  "  //7)
        <<pt_max        <<"  "  //3)
        <<random_seed        <<"  "  //-1)
        <<subs_max        <<"  "  //3)
        <<dash_power_rate_delta_max        <<"  "  //0.002)
        <<dash_power_rate_delta_min        <<"  "  //0)
        <<effort_max_delta_factor        <<"  "  //-0.002)
        <<effort_min_delta_factor        <<"  "  //-0.002)
        <<extra_stamina_delta_max        <<"  "  //100)
        <<extra_stamina_delta_min        <<"  "  //0)
        <<inertia_moment_delta_factor        <<"  "  //25)
        <<kick_rand_delta_factor        <<"  "  //0.5)
        <<kickable_margin_delta_max        <<"  "  //0.2)
        <<kickable_margin_delta_min        <<"  "  //0)
        <<new_dash_power_rate_delta_max        <<"  "  //0.002)
        <<new_dash_power_rate_delta_min        <<"  "  //0)
        <<new_stamina_inc_max_delta_factor        <<"  "  //-10000)
        <<player_decay_delta_max        <<"  "  //0.2)
        <<player_decay_delta_min        <<"  "  //0)
        <<player_size_delta_factor        <<"  "  //-100)
        <<player_speed_max_delta_max        <<"  "  //0.2)
        <<player_speed_max_delta_min        <<"  "  //0)
        <<stamina_inc_max_delta_factor        <<endl;  //-100)
    return 0;
}



int HetroPlayerType::SetHetroPlayerType(const char* hpt)
{
    strstream sp;
    string strBuf;
    sp  <<  hpt;
    sp  >>                          strBuf  >>  strBuf
        >>  id                  >>  strBuf  >>  strBuf
        >>  player_speed_Max    >>  strBuf  >>  strBuf
        >>  staMina_inc_Max     >>  strBuf  >>  strBuf
        >>  player_decay        >>  strBuf  >>  strBuf
        >>  inertia_moment      >>  strBuf  >>  strBuf
        >>  dash_power_rate     >>  strBuf  >>  strBuf
        >>  player_size         >>  strBuf  >>  strBuf
        >>  kickable_margin     >>  strBuf  >>  strBuf
        >>  kick_rand           >>  strBuf  >>  strBuf
        >>  extra_staMina       >>  strBuf  >>  strBuf
        >>  effort_Max          >>  strBuf  >>  strBuf
        >>  effort_Min;

    return 0;
}

int HetroPlayerType::OutHetroPlayerType()
{
    cout<<                          " "  <<  " "
        <<  id                  <<  " "  <<  " "
        <<  player_speed_Max    <<  " "  <<  " "
        <<  staMina_inc_Max     <<  " "  <<  " "
        <<  player_decay        <<  " "  <<  " "
        <<  inertia_moment      <<  " "  <<  " "
        <<  dash_power_rate     <<  " "  <<  " "
        <<  player_size         <<  " "  <<  " "
        <<  kickable_margin     <<  " "  <<  " "
        <<  kick_rand           <<  " "  <<  " "
        <<  extra_staMina       <<  " "  <<  " "
        <<  effort_Max          <<  " "  <<  " "
        <<  effort_Min          <<  endl;

    return 0;
}




PlayerTypeSetting::PlayerTypeSetting(void)
{
}

void PlayerTypeSetting::SetLogger(Logger *log)
{
    l = log;
}

int PlayerTypeSetting::SetPlayerTypeParameters(const char* pt)
{
    string  strBuf;
    int iType;
    strstream sp;
    sp  <<  pt;
    sp  >>  strBuf >> strBuf >> iType;
    type[iType].SetHetroPlayerType(pt);
    
    return 0;
}

int PlayerTypeSetting::OutPlayerTypeParameters()
{
    for(int i=0;i<MAX_TYPE_NUMBER;i++)
    {
        type[i].OutHetroPlayerType();
    }
    return 0;
}




int PlayerTypeSetting::SortPlayerType()
{
    l->Log(0,"\n\n****************** analyze player type ************************");
    
    //add your evaluation functions here    
    
    l->Log(0,"\n^^^^^^^^^^^^^^^^^^^^^^^^^^^\n\n");
    return 0;
}


int PlayerTypeSetting::SelectForwardCenter()
{
    int bestType=0;
    double bestTypeUtility=0;
    for(int i=0;i<MAX_TYPE_NUMBER;i++)
    {
        if(typeTable[PT_FORWARD_CENTER][i]>bestTypeUtility 
            && typeOnField[i]<TYPE_ON_FIELD_NUMBER)
        {
            bestType = i;
            bestTypeUtility = typeTable[PT_FORWARD_CENTER][i];
        }
    }
    if(bestType != 0) typeOnField[bestType] += 1;
    return bestType;
}

int PlayerTypeSetting::SelectForwardSide()
{
    int bestType=0;
    double bestTypeUtility=0;
    for(int i=0;i<MAX_TYPE_NUMBER;i++)
    {
        if(typeTable[PT_FORWARD_SIDE][i]>bestTypeUtility 
            && typeOnField[i]<TYPE_ON_FIELD_NUMBER)
        {
            bestType = i;
            bestTypeUtility = typeTable[PT_FORWARD_SIDE][i];
        }   
    }
    if(bestType != 0) typeOnField[bestType] += 1;
    return bestType;
}

int PlayerTypeSetting::SelectBackCenter()
{
    int bestType=0;
    double bestTypeUtility=0;
    for(int i=0;i<MAX_TYPE_NUMBER;i++)
    {
//cout<<"back center weight == "<<typeTable[PT_BACK_CENTER][i]<<endl;
        if(typeTable[PT_BACK_CENTER][i]>bestTypeUtility 
            && typeOnField[i]<TYPE_ON_FIELD_NUMBER)
        {
            bestType = i;
            bestTypeUtility = typeTable[PT_BACK_CENTER][i];
        }   
    }
    if(bestType != 0) typeOnField[bestType] += 1;
    return bestType;
}

int PlayerTypeSetting::SelectBackSide()
{
    int bestType=0;
    double bestTypeUtility=0;
    for(int i=0;i<MAX_TYPE_NUMBER;i++)
    {
        if(typeTable[PT_BACK_SIDE][i]>bestTypeUtility 
            && typeOnField[i]<TYPE_ON_FIELD_NUMBER)
        {
            bestType = i;
            bestTypeUtility = typeTable[PT_BACK_SIDE][i];
        }   
    }
    if(bestType != 0) typeOnField[bestType] += 1;
    return bestType;
}

int PlayerTypeSetting::SelectMiddle()
{
    int bestType=0;
    double bestTypeUtility=0;
    for(int i=0;i<MAX_TYPE_NUMBER;i++)
    {
        if(typeTable[PT_MIDFIELD][i]>bestTypeUtility 
            && typeOnField[i]<TYPE_ON_FIELD_NUMBER)
        {
            bestType = i;
            bestTypeUtility = typeTable[PT_MIDFIELD][i];
        }   
    }
    if(bestType != 0) typeOnField[bestType] += 1;
    return bestType;
}



